MCP Tools Reference: backupdr.googleapis.com

Tool: ListBackups

Lists all backups associated with a specific data source. Use this to find available recovery points.

The following sample demonstrate how to use curl to invoke the ListBackups MCP tool.

Curl Request
                  
curl --location 'https://backupdr.googleapis.com/mcp' \
--header 'content-type: application/json' \
--header 'accept: application/json, text/event-stream' \
--data '{
  "method": "tools/call",
  "params": {
    "name": "ListBackups",
    "arguments": {
      // provide these details according to the tool's MCP specification
    }
  },
  "jsonrpc": "2.0",
  "id": 1
}'
                

Input Schema

Request message for listing Backups.

ListBackupsRequest

JSON representation
{
  "parent": string,
  "pageSize": integer,
  "pageToken": string,
  "filter": string,
  "orderBy": string,
  "view": enum (BackupView)
}
Fields
parent

string

Required. The project and location for which to retrieve backup information, in the format 'projects/{project_id}/locations/{location}'. In Cloud Backup and DR, locations map to Google Cloud regions, for example us-central1. To retrieve data sources for all locations, use "-" for the '{location}' value.

pageSize

integer

Optional. Requested page size. Server may return fewer items than requested. If unspecified, server will pick an appropriate default.

pageToken

string

Optional. A token identifying a page of results the server should return.

filter

string

Optional. Filtering results.

orderBy

string

Optional. Hint for how to order the results.

view

enum (BackupView)

Optional. Reserved for future use to provide a BASIC & FULL view of Backup resource.

BackupView

BackupView contains enum options for Partial and Full view.

Enums
BACKUP_VIEW_UNSPECIFIED If the value is not set, the default 'FULL' view is used.
BACKUP_VIEW_BASIC Includes basic data about the Backup, but not the full contents.
BACKUP_VIEW_FULL Includes all data about the Backup. This is the default value (for both ListBackups and GetBackup).

Output Schema

Response message for listing Backups.

ListBackupsResponse

JSON representation
{
  "backups": [
    {
      object (Backup)
    }
  ],
  "nextPageToken": string,
  "unreachable": [
    string
  ]
}
Fields
backups[]

object (Backup)

The list of Backup instances in the project for the specified location.

If the '{location}' value in the request is "-", the response contains a list of instances from all locations. In case any location is unreachable, the response will only return data sources in reachable locations and the 'unreachable' field will be populated with a list of unreachable locations.

nextPageToken

string

A token identifying a page of results the server should return.

unreachable[]

string

Locations that could not be reached.

Backup

JSON representation
{
  "name": string,
  "labels": {
    string: string,
    ...
  },
  "state": enum (State),
  "serviceLocks": [
    {
      object (BackupLock)
    }
  ],
  "backupApplianceLocks": [
    {
      object (BackupLock)
    }
  ],
  "backupType": enum (BackupType),
  "resourceSizeBytes": string,
  "kmsKeyVersions": [
    string
  ],

  // Union field _description can be only one of the following:
  "description": string
  // End of list of possible types for union field _description.

  // Union field _create_time can be only one of the following:
  "createTime": string
  // End of list of possible types for union field _create_time.

  // Union field _update_time can be only one of the following:
  "updateTime": string
  // End of list of possible types for union field _update_time.

  // Union field _enforced_retention_end_time can be only one of the following:
  "enforcedRetentionEndTime": string
  // End of list of possible types for union field _enforced_retention_end_time.

  // Union field _backup_retention_inheritance can be only one of the following:
  "backupRetentionInheritance": enum (BackupRetentionInheritance)
  // End of list of possible types for union field _backup_retention_inheritance.

  // Union field _expire_time can be only one of the following:
  "expireTime": string
  // End of list of possible types for union field _expire_time.

  // Union field _consistency_time can be only one of the following:
  "consistencyTime": string
  // End of list of possible types for union field _consistency_time.

  // Union field _etag can be only one of the following:
  "etag": string
  // End of list of possible types for union field _etag.

  // Union field backup_properties can be only one of the following:
  "computeInstanceBackupProperties": {
    object (ComputeInstanceBackupProperties)
  },
  "cloudSqlInstanceBackupProperties": {
    object (CloudSqlInstanceBackupProperties)
  },
  "backupApplianceBackupProperties": {
    object (BackupApplianceBackupProperties)
  },
  "alloyDbBackupProperties": {
    object (AlloyDbClusterBackupProperties)
  },
  "diskBackupProperties": {
    object (DiskBackupProperties)
  },
  "filestoreInstanceBackupProperties": {
    object (FilestoreInstanceBackupProperties)
  }
  // End of list of possible types for union field backup_properties.

  // Union field plan_info can be only one of the following:
  "gcpBackupPlanInfo": {
    object (GCPBackupPlanInfo)
  }
  // End of list of possible types for union field plan_info.

  // Union field _satisfies_pzs can be only one of the following:
  "satisfiesPzs": boolean
  // End of list of possible types for union field _satisfies_pzs.

  // Union field _satisfies_pzi can be only one of the following:
  "satisfiesPzi": boolean
  // End of list of possible types for union field _satisfies_pzi.

  // Union field source_resource can be only one of the following:
  "gcpResource": {
    object (BackupGcpResource)
  }
  // End of list of possible types for union field source_resource.
}
Fields
name

string

Output only. Identifier. Name of the backup to create. It must have the format"projects/<project>/locations/<location>/backupVaults/<backupvault>/dataSources/{datasource}/backups/{backup}". {backup} cannot be changed after creation. It must be between 3-63 characters long and must be unique within the datasource.

labels

map (key: string, value: string)

Optional. Resource labels to represent user provided metadata. No labels currently defined.

An object containing a list of "key": value pairs. Example: { "name": "wrench", "mass": "1.3kg", "count": "3" }.

state

enum (State)

Output only. The Backup resource instance state.

serviceLocks[]

object (BackupLock)

Output only. The list of BackupLocks taken by the service to prevent the deletion of the backup.

backupApplianceLocks[]

object (BackupLock)

Optional. The list of BackupLocks taken by the accessor Backup Appliance.

backupType

enum (BackupType)

Output only. Type of the backup, unspecified, scheduled or ondemand.

resourceSizeBytes

string (int64 format)

Output only. source resource size in bytes at the time of the backup.

kmsKeyVersions[]

string

Optional. Output only. The list of KMS key versions used to encrypt the backup.

Union field _description.

_description can be only one of the following:

description

string

Output only. The description of the Backup instance (2048 characters or less).

Union field _create_time.

_create_time can be only one of the following:

createTime

string (Timestamp format)

Output only. The time when the instance was created.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

Union field _update_time.

_update_time can be only one of the following:

updateTime

string (Timestamp format)

Output only. The time when the instance was updated.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

Union field _enforced_retention_end_time.

_enforced_retention_end_time can be only one of the following:

enforcedRetentionEndTime

string (Timestamp format)

Optional. The backup can not be deleted before this time.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

Union field _backup_retention_inheritance.

_backup_retention_inheritance can be only one of the following:

backupRetentionInheritance

enum (BackupRetentionInheritance)

Output only. Setting for how the enforced retention end time is inherited. This value is copied from this backup's BackupVault.

Union field _expire_time.

_expire_time can be only one of the following:

expireTime

string (Timestamp format)

Optional. When this backup is automatically expired.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

Union field _consistency_time.

_consistency_time can be only one of the following:

consistencyTime

string (Timestamp format)

Output only. The point in time when this backup was captured from the source.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

Union field _etag.

_etag can be only one of the following:

etag

string

Optional. Server specified ETag to prevent updates from overwriting each other.

Union field backup_properties. Workload specific backup properties. backup_properties can be only one of the following:
computeInstanceBackupProperties

object (ComputeInstanceBackupProperties)

Output only. Compute Engine specific backup properties.

cloudSqlInstanceBackupProperties

object (CloudSqlInstanceBackupProperties)

Output only. Cloud SQL specific backup properties.

backupApplianceBackupProperties

object (BackupApplianceBackupProperties)

Output only. Backup Appliance specific backup properties.

alloyDbBackupProperties

object (AlloyDbClusterBackupProperties)

Output only. AlloyDB specific backup properties.

diskBackupProperties

object (DiskBackupProperties)

Output only. Disk specific backup properties.

filestoreInstanceBackupProperties

object (FilestoreInstanceBackupProperties)

Output only. Filestore specific backup properties.

Union field plan_info. Configuration Info has the resource format-specific configuration. plan_info can be only one of the following:
gcpBackupPlanInfo

object (GCPBackupPlanInfo)

Output only. Configuration for a Google Cloud resource.

Union field _satisfies_pzs.

_satisfies_pzs can be only one of the following:

satisfiesPzs

boolean

Optional. Output only. Reserved for future use.

Union field _satisfies_pzi.

_satisfies_pzi can be only one of the following:

satisfiesPzi

boolean

Optional. Output only. Reserved for future use.

Union field source_resource. Resource that is being backed up. source_resource can be only one of the following:
gcpResource

object (BackupGcpResource)

Output only. Unique identifier of the GCP resource that is being backed up.

Timestamp

JSON representation
{
  "seconds": string,
  "nanos": integer
}
Fields
seconds

string (int64 format)

Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be between -62135596800 and 253402300799 inclusive (which corresponds to 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z).

nanos

integer

Non-negative fractions of a second at nanosecond resolution. This field is the nanosecond portion of the duration, not an alternative to seconds. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be between 0 and 999,999,999 inclusive.

LabelsEntry

JSON representation
{
  "key": string,
  "value": string
}
Fields
key

string

value

string

BackupLock

JSON representation
{
  "lockUntilTime": string,

  // Union field ClientLockInfo can be only one of the following:
  "backupApplianceLockInfo": {
    object (BackupApplianceLockInfo)
  },
  "serviceLockInfo": {
    object (ServiceLockInfo)
  }
  // End of list of possible types for union field ClientLockInfo.
}
Fields
lockUntilTime

string (Timestamp format)

Required. The time after which this lock is not considered valid and will no longer protect the Backup from deletion.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

Union field ClientLockInfo. Metadata about the owner and reason for the lock. ClientLockInfo can be only one of the following:
backupApplianceLockInfo

object (BackupApplianceLockInfo)

If the client is a backup and recovery appliance, this contains metadata about why the lock exists.

serviceLockInfo

object (ServiceLockInfo)

Output only. Contains metadata about the lock exist for Google Cloud native backups.

BackupApplianceLockInfo

JSON representation
{
  "backupApplianceId": string,
  "backupApplianceName": string,
  "lockReason": string,

  // Union field lock_source can be only one of the following:
  "jobName": string,
  "backupImage": string,
  "slaId": string
  // End of list of possible types for union field lock_source.
}
Fields
backupApplianceId

string (int64 format)

Required. The ID of the backup/recovery appliance that created this lock.

backupApplianceName

string

Required. The name of the backup/recovery appliance that created this lock.

lockReason

string

Required. The reason for the lock: e.g. MOUNT/RESTORE/BACKUP/etc. The value of this string is only meaningful to the client and it is not interpreted by the BackupVault service.

Union field lock_source. The information about this lock. lock_source can be only one of the following:
jobName

string

The job name on the backup/recovery appliance that created this lock.

backupImage

string

The image name that depends on this Backup.

slaId

string (int64 format)

The SLA on the backup/recovery appliance that owns the lock.

ServiceLockInfo

JSON representation
{
  "operation": string
}
Fields
operation

string

Output only. The name of the operation that created this lock. The lock will automatically be released when the operation completes.

ComputeInstanceBackupProperties

JSON representation
{
  "networkInterface": [
    {
      object (NetworkInterface)
    }
  ],
  "disk": [
    {
      object (AttachedDisk)
    }
  ],
  "serviceAccount": [
    {
      object (ServiceAccount)
    }
  ],
  "guestAccelerator": [
    {
      object (AcceleratorConfig)
    }
  ],
  "labels": {
    string: string,
    ...
  },
  "guestFlush": boolean,

  // Union field _description can be only one of the following:
  "description": string
  // End of list of possible types for union field _description.

  // Union field _tags can be only one of the following:
  "tags": {
    object (Tags)
  }
  // End of list of possible types for union field _tags.

  // Union field _machine_type can be only one of the following:
  "machineType": string
  // End of list of possible types for union field _machine_type.

  // Union field _can_ip_forward can be only one of the following:
  "canIpForward": boolean
  // End of list of possible types for union field _can_ip_forward.

  // Union field _metadata can be only one of the following:
  "metadata": {
    object (Metadata)
  }
  // End of list of possible types for union field _metadata.

  // Union field _scheduling can be only one of the following:
  "scheduling": {
    object (Scheduling)
  }
  // End of list of possible types for union field _scheduling.

  // Union field _min_cpu_platform can be only one of the following:
  "minCpuPlatform": string
  // End of list of possible types for union field _min_cpu_platform.

  // Union field _key_revocation_action_type can be only one of the following:
  "keyRevocationActionType": enum (KeyRevocationActionType)
  // End of list of possible types for union field _key_revocation_action_type.

  // Union field _source_instance can be only one of the following:
  "sourceInstance": string
  // End of list of possible types for union field _source_instance.
}
Fields
networkInterface[]

object (NetworkInterface)

An array of network access configurations for this interface.

disk[]

object (AttachedDisk)

An array of disks that are associated with the instances that are created from these properties.

serviceAccount[]

object (ServiceAccount)

A list of service accounts with specified scopes. Access tokens for these service accounts are available to the instances that are created from these properties. Use metadata queries to obtain the access tokens for these instances.

guestAccelerator[]

object (AcceleratorConfig)

A list of guest accelerator cards' type and count to use for instances created from these properties.

labels

map (key: string, value: string)

Labels to apply to instances that are created from these properties.

An object containing a list of "key": value pairs. Example: { "name": "wrench", "mass": "1.3kg", "count": "3" }.

guestFlush

boolean

Optional. Indicates whether to perform a guest flush operation before taking a compute backup. When set to false, the system will create crash-consistent backups. Default value is false.

Union field _description.

_description can be only one of the following:

description

string

An optional text description for the instances that are created from these properties.

Union field _tags.

_tags can be only one of the following:

tags

object (Tags)

A list of tags to apply to the instances that are created from these properties. The tags identify valid sources or targets for network firewalls. The setTags method can modify this list of tags. Each tag within the list must comply with RFC1035 (https://www.ietf.org/rfc/rfc1035.txt).

Union field _machine_type.

_machine_type can be only one of the following:

machineType

string

The machine type to use for instances that are created from these properties.

Union field _can_ip_forward.

_can_ip_forward can be only one of the following:

canIpForward

boolean

Enables instances created based on these properties to send packets with source IP addresses other than their own and receive packets with destination IP addresses other than their own. If these instances will be used as an IP gateway or it will be set as the next-hop in a Route resource, specify true. If unsure, leave this set to false. See the https://cloud.google.com/vpc/docs/using-routes#canipforward documentation for more information.

Union field _metadata.

_metadata can be only one of the following:

metadata

object (Metadata)

The metadata key/value pairs to assign to instances that are created from these properties. These pairs can consist of custom metadata or predefined keys. See https://cloud.google.com/compute/docs/metadata/overview for more information.

Union field _scheduling.

_scheduling can be only one of the following:

scheduling

object (Scheduling)

Specifies the scheduling options for the instances that are created from these properties.

Union field _min_cpu_platform.

_min_cpu_platform can be only one of the following:

minCpuPlatform

string

Minimum cpu/platform to be used by instances. The instance may be scheduled on the specified or newer cpu/platform. Applicable values are the friendly names of CPU platforms, such as minCpuPlatform: Intel Haswell or minCpuPlatform: Intel Sandy Bridge. For more information, read https://cloud.google.com/compute/docs/instances/specify-min-cpu-platform.

Union field _key_revocation_action_type.

_key_revocation_action_type can be only one of the following:

keyRevocationActionType

enum (KeyRevocationActionType)

KeyRevocationActionType of the instance. Supported options are "STOP" and "NONE". The default value is "NONE" if it is not specified.

Union field _source_instance.

_source_instance can be only one of the following:

sourceInstance

string

The source instance used to create this backup. This can be a partial or full URL to the resource. For example, the following are valid values: -https://www.googleapis.com/compute/v1/projects/project/zones/zone/instances/instance -projects/project/zones/zone/instances/instance

Tags

JSON representation
{
  "items": [
    string
  ]
}
Fields
items[]

string

Optional. An array of tags. Each tag must be 1-63 characters long, and comply with RFC1035.

NetworkInterface

JSON representation
{
  "accessConfigs": [
    {
      object (AccessConfig)
    }
  ],
  "ipv6AccessConfigs": [
    {
      object (AccessConfig)
    }
  ],
  "aliasIpRanges": [
    {
      object (AliasIpRange)
    }
  ],

  // Union field _network can be only one of the following:
  "network": string
  // End of list of possible types for union field _network.

  // Union field _subnetwork can be only one of the following:
  "subnetwork": string
  // End of list of possible types for union field _subnetwork.

  // Union field _ip_address can be only one of the following:
  "networkIP": string
  // End of list of possible types for union field _ip_address.

  // Union field _ipv6_address can be only one of the following:
  "ipv6Address": string
  // End of list of possible types for union field _ipv6_address.

  // Union field _internal_ipv6_prefix_length can be only one of the following:
  "internalIpv6PrefixLength": integer
  // End of list of possible types for union field _internal_ipv6_prefix_length.

  // Union field _name can be only one of the following:
  "name": string
  // End of list of possible types for union field _name.

  // Union field _stack_type can be only one of the following:
  "stackType": enum (StackType)
  // End of list of possible types for union field _stack_type.

  // Union field _ipv6_access_type can be only one of the following:
  "ipv6AccessType": enum (Ipv6AccessType)
  // End of list of possible types for union field _ipv6_access_type.

  // Union field _queue_count can be only one of the following:
  "queueCount": integer
  // End of list of possible types for union field _queue_count.

  // Union field _nic_type can be only one of the following:
  "nicType": enum (NicType)
  // End of list of possible types for union field _nic_type.

  // Union field _network_attachment can be only one of the following:
  "networkAttachment": string
  // End of list of possible types for union field _network_attachment.
}
Fields
accessConfigs[]

object (AccessConfig)

Optional. An array of configurations for this interface. Currently, only one access config,ONE_TO_ONE_NAT is supported. If there are no accessConfigs specified, then this instance will have no external internet access.

ipv6AccessConfigs[]

object (AccessConfig)

Optional. An array of IPv6 access configurations for this interface. Currently, only one IPv6 access config, DIRECT_IPV6, is supported. If there is no ipv6AccessConfig specified, then this instance will have no external IPv6 Internet access.

aliasIpRanges[]

object (AliasIpRange)

Optional. An array of alias IP ranges for this network interface. You can only specify this field for network interfaces in VPC networks.

Union field _network.

_network can be only one of the following:

network

string

Optional. URL of the VPC network resource for this instance.

Union field _subnetwork.

_subnetwork can be only one of the following:

subnetwork

string

Optional. The URL of the Subnetwork resource for this instance.

Union field _ip_address.

_ip_address can be only one of the following:

networkIP

string

Optional. An IPv4 internal IP address to assign to the instance for this network interface. If not specified by the user, an unused internal IP is assigned by the system.

Union field _ipv6_address.

_ipv6_address can be only one of the following:

ipv6Address

string

Optional. An IPv6 internal network address for this network interface. To use a static internal IP address, it must be unused and in the same region as the instance's zone. If not specified, Google Cloud will automatically assign an internal IPv6 address from the instance's subnetwork.

Union field _internal_ipv6_prefix_length.

_internal_ipv6_prefix_length can be only one of the following:

internalIpv6PrefixLength

integer

Optional. The prefix length of the primary internal IPv6 range.

Union field _name.

_name can be only one of the following:

name

string

Output only. [Output Only] The name of the network interface, which is generated by the server.

Union field _stack_type.

_stack_type can be only one of the following:

stackType

enum (StackType)

The stack type for this network interface.

Union field _ipv6_access_type.

_ipv6_access_type can be only one of the following:

ipv6AccessType

enum (Ipv6AccessType)

Optional. [Output Only] One of EXTERNAL, INTERNAL to indicate whether the IP can be accessed from the Internet. This field is always inherited from its subnetwork.

Union field _queue_count.

_queue_count can be only one of the following:

queueCount

integer

Optional. The networking queue count that's specified by users for the network interface. Both Rx and Tx queues will be set to this number. It'll be empty if not specified by the users.

Union field _nic_type.

_nic_type can be only one of the following:

nicType

enum (NicType)

Optional. The type of vNIC to be used on this interface. This may be gVNIC or VirtioNet.

Union field _network_attachment.

_network_attachment can be only one of the following:

networkAttachment

string

Optional. The URL of the network attachment that this interface should connect to in the following format: projects/{project_number}/regions/{region_name}/networkAttachments/{network_attachment_name}.

AccessConfig

JSON representation
{

  // Union field _type can be only one of the following:
  "type": enum (AccessType)
  // End of list of possible types for union field _type.

  // Union field _name can be only one of the following:
  "name": string
  // End of list of possible types for union field _name.

  // Union field _external_ip can be only one of the following:
  "natIP": string
  // End of list of possible types for union field _external_ip.

  // Union field _external_ipv6 can be only one of the following:
  "externalIpv6": string
  // End of list of possible types for union field _external_ipv6.

  // Union field _external_ipv6_prefix_length can be only one of the following:
  "externalIpv6PrefixLength": integer
  // End of list of possible types for union field _external_ipv6_prefix_length.

  // Union field _set_public_ptr can be only one of the following:
  "setPublicPtr": boolean
  // End of list of possible types for union field _set_public_ptr.

  // Union field _public_ptr_domain_name can be only one of the following:
  "publicPtrDomainName": string
  // End of list of possible types for union field _public_ptr_domain_name.

  // Union field _network_tier can be only one of the following:
  "networkTier": enum (NetworkTier)
  // End of list of possible types for union field _network_tier.
}
Fields

Union field _type.

_type can be only one of the following:

type

enum (AccessType)

Optional. In accessConfigs (IPv4), the default and only option is ONE_TO_ONE_NAT. In ipv6AccessConfigs, the default and only option is DIRECT_IPV6.

Union field _name.

_name can be only one of the following:

name

string

Optional. The name of this access configuration.

Union field _external_ip.

_external_ip can be only one of the following:

natIP

string

Optional. The external IP address of this access configuration.

Union field _external_ipv6.

_external_ipv6 can be only one of the following:

externalIpv6

string

Optional. The external IPv6 address of this access configuration.

Union field _external_ipv6_prefix_length.

_external_ipv6_prefix_length can be only one of the following:

externalIpv6PrefixLength

integer

Optional. The prefix length of the external IPv6 range.

Union field _set_public_ptr.

_set_public_ptr can be only one of the following:

setPublicPtr

boolean

Optional. Specifies whether a public DNS 'PTR' record should be created to map the external IP address of the instance to a DNS domain name.

Union field _public_ptr_domain_name.

_public_ptr_domain_name can be only one of the following:

publicPtrDomainName

string

Optional. The DNS domain name for the public PTR record.

Union field _network_tier.

_network_tier can be only one of the following:

networkTier

enum (NetworkTier)

Optional. This signifies the networking tier used for configuring this access

AliasIpRange

JSON representation
{

  // Union field _ip_cidr_range can be only one of the following:
  "ipCidrRange": string
  // End of list of possible types for union field _ip_cidr_range.

  // Union field _subnetwork_range_name can be only one of the following:
  "subnetworkRangeName": string
  // End of list of possible types for union field _subnetwork_range_name.
}
Fields

Union field _ip_cidr_range.

_ip_cidr_range can be only one of the following:

ipCidrRange

string

Optional. The IP alias ranges to allocate for this interface.

Union field _subnetwork_range_name.

_subnetwork_range_name can be only one of the following:

subnetworkRangeName

string

Optional. The name of a subnetwork secondary IP range from which to allocate an IP alias range. If not specified, the primary range of the subnetwork is used.

AttachedDisk

JSON representation
{
  "license": [
    string
  ],
  "guestOsFeature": [
    {
      object (GuestOsFeature)
    }
  ],

  // Union field _initialize_params can be only one of the following:
  "initializeParams": {
    object (InitializeParams)
  }
  // End of list of possible types for union field _initialize_params.

  // Union field _device_name can be only one of the following:
  "deviceName": string
  // End of list of possible types for union field _device_name.

  // Union field _kind can be only one of the following:
  "kind": string
  // End of list of possible types for union field _kind.

  // Union field _disk_type_deprecated can be only one of the following:
  "diskTypeDeprecated": enum (DiskType)
  // End of list of possible types for union field _disk_type_deprecated.

  // Union field _mode can be only one of the following:
  "mode": enum (DiskMode)
  // End of list of possible types for union field _mode.

  // Union field _source can be only one of the following:
  "source": string
  // End of list of possible types for union field _source.

  // Union field _index can be only one of the following:
  "index": string
  // End of list of possible types for union field _index.

  // Union field _boot can be only one of the following:
  "boot": boolean
  // End of list of possible types for union field _boot.

  // Union field _auto_delete can be only one of the following:
  "autoDelete": boolean
  // End of list of possible types for union field _auto_delete.

  // Union field _disk_interface can be only one of the following:
  "diskInterface": enum (DiskInterface)
  // End of list of possible types for union field _disk_interface.

  // Union field _disk_encryption_key can be only one of the following:
  "diskEncryptionKey": {
    object (CustomerEncryptionKey)
  }
  // End of list of possible types for union field _disk_encryption_key.

  // Union field _disk_size_gb can be only one of the following:
  "diskSizeGb": string
  // End of list of possible types for union field _disk_size_gb.

  // Union field _saved_state can be only one of the following:
  "savedState": enum (DiskSavedState)
  // End of list of possible types for union field _saved_state.

  // Union field _disk_type can be only one of the following:
  "diskType": string
  // End of list of possible types for union field _disk_type.

  // Union field _type can be only one of the following:
  "type": enum (DiskType)
  // End of list of possible types for union field _type.
}
Fields
license[]

string

Optional. Any valid publicly visible licenses.

guestOsFeature[]

object (GuestOsFeature)

Optional. A list of features to enable on the guest operating system. Applicable only for bootable images.

Union field _initialize_params.

_initialize_params can be only one of the following:

initializeParams

object (InitializeParams)

Optional. Specifies the parameters to initialize this disk.

Union field _device_name.

_device_name can be only one of the following:

deviceName

string

Optional. This is used as an identifier for the disks. This is the unique name has to provided to modify disk parameters like disk_name and replica_zones (in case of RePDs)

Union field _kind.

_kind can be only one of the following:

kind

string

Optional. Type of the resource.

Union field _disk_type_deprecated.

_disk_type_deprecated can be only one of the following:

diskTypeDeprecated
(deprecated)

enum (DiskType)

Specifies the type of the disk.

Union field _mode.

_mode can be only one of the following:

mode

enum (DiskMode)

Optional. The mode in which to attach this disk.

Union field _source.

_source can be only one of the following:

source

string

Optional. Specifies a valid partial or full URL to an existing Persistent Disk resource.

Union field _index.

_index can be only one of the following:

index

string (int64 format)

Optional. A zero-based index to this disk, where 0 is reserved for the boot disk.

Union field _boot.

_boot can be only one of the following:

boot

boolean

Optional. Indicates that this is a boot disk. The virtual machine will use the first partition of the disk for its root filesystem.

Union field _auto_delete.

_auto_delete can be only one of the following:

autoDelete

boolean

Optional. Specifies whether the disk will be auto-deleted when the instance is deleted (but not when the disk is detached from the instance).

Union field _disk_interface.

_disk_interface can be only one of the following:

diskInterface

enum (DiskInterface)

Optional. Specifies the disk interface to use for attaching this disk.

Union field _disk_encryption_key.

_disk_encryption_key can be only one of the following:

diskEncryptionKey

object (CustomerEncryptionKey)

Optional. Encrypts or decrypts a disk using a customer-supplied encryption key.

Union field _disk_size_gb.

_disk_size_gb can be only one of the following:

diskSizeGb

string (int64 format)

Optional. The size of the disk in GB.

Union field _saved_state.

_saved_state can be only one of the following:

savedState

enum (DiskSavedState)

Optional. Output only. The state of the disk.

Union field _disk_type.

_disk_type can be only one of the following:

diskType

string

Optional. Output only. The URI of the disk type resource. For example: projects/project/zones/zone/diskTypes/pd-standard or pd-ssd

Union field _type.

_type can be only one of the following:

type

enum (DiskType)

Optional. Specifies the type of the disk.

InitializeParams

JSON representation
{
  "replicaZones": [
    string
  ],

  // Union field _disk_name can be only one of the following:
  "diskName": string
  // End of list of possible types for union field _disk_name.
}
Fields
replicaZones[]

string

Optional. URL of the zone where the disk should be created. Required for each regional disk associated with the instance.

Union field _disk_name.

_disk_name can be only one of the following:

diskName

string

Optional. Specifies the disk name. If not specified, the default is to use the name of the instance.

GuestOsFeature

JSON representation
{

  // Union field _type can be only one of the following:
  "type": enum (FeatureType)
  // End of list of possible types for union field _type.
}
Fields

Union field _type.

_type can be only one of the following:

type

enum (FeatureType)

The ID of a supported feature.

CustomerEncryptionKey

JSON representation
{

  // Union field key can be only one of the following:
  "rawKey": string,
  "rsaEncryptedKey": string,
  "kmsKeyName": string
  // End of list of possible types for union field key.

  // Union field _kms_key_service_account can be only one of the following:
  "kmsKeyServiceAccount": string
  // End of list of possible types for union field _kms_key_service_account.
}
Fields
Union field key. The key to use for encryption. key can be only one of the following:
rawKey

string

Optional. Specifies a 256-bit customer-supplied encryption key.

rsaEncryptedKey

string

Optional. RSA-wrapped 2048-bit customer-supplied encryption key to either encrypt or decrypt this resource.

kmsKeyName

string

Optional. The name of the encryption key that is stored in Google Cloud KMS.

Union field _kms_key_service_account.

_kms_key_service_account can be only one of the following:

kmsKeyServiceAccount

string

Optional. The service account being used for the encryption request for the given KMS key. If absent, the Compute Engine default service account is used.

Metadata

JSON representation
{
  "items": [
    {
      object (Entry)
    }
  ]
}
Fields
items[]

object (Entry)

Optional. Array of key/value pairs. The total size of all keys and values must be less than 512 KB.

Entry

JSON representation
{

  // Union field _key can be only one of the following:
  "key": string
  // End of list of possible types for union field _key.

  // Union field _value can be only one of the following:
  "value": string
  // End of list of possible types for union field _value.
}
Fields

Union field _key.

_key can be only one of the following:

key

string

Optional. Key for the metadata entry.

Union field _value.

_value can be only one of the following:

value

string

Optional. Value for the metadata entry. These are free-form strings, and only have meaning as interpreted by the image running in the instance. The only restriction placed on values is that their size must be less than or equal to 262144 bytes (256 KiB).

ServiceAccount

JSON representation
{
  "scopes": [
    string
  ],

  // Union field _email can be only one of the following:
  "email": string
  // End of list of possible types for union field _email.
}
Fields
scopes[]

string

Optional. The list of scopes to be made available for this service account.

Union field _email.

_email can be only one of the following:

email

string

Optional. Email address of the service account.

Scheduling

JSON representation
{
  "nodeAffinities": [
    {
      object (NodeAffinity)
    }
  ],

  // Union field _on_host_maintenance can be only one of the following:
  "onHostMaintenance": enum (OnHostMaintenance)
  // End of list of possible types for union field _on_host_maintenance.

  // Union field _automatic_restart can be only one of the following:
  "automaticRestart": boolean
  // End of list of possible types for union field _automatic_restart.

  // Union field _preemptible can be only one of the following:
  "preemptible": boolean
  // End of list of possible types for union field _preemptible.

  // Union field _min_node_cpus can be only one of the following:
  "minNodeCpus": integer
  // End of list of possible types for union field _min_node_cpus.

  // Union field _provisioning_model can be only one of the following:
  "provisioningModel": enum (ProvisioningModel)
  // End of list of possible types for union field _provisioning_model.

  // Union field _instance_termination_action can be only one of the following:
  "instanceTerminationAction": enum (InstanceTerminationAction)
  // End of list of possible types for union field _instance_termination_action.

  // Union field _local_ssd_recovery_timeout can be only one of the following:
  "localSsdRecoveryTimeout": {
    object (SchedulingDuration)
  }
  // End of list of possible types for union field _local_ssd_recovery_timeout.
}
Fields
nodeAffinities[]

object (NodeAffinity)

Optional. A set of node affinity and anti-affinity configurations. Overrides reservationAffinity.

Union field _on_host_maintenance.

_on_host_maintenance can be only one of the following:

onHostMaintenance

enum (OnHostMaintenance)

Optional. Defines the maintenance behavior for this instance.

Union field _automatic_restart.

_automatic_restart can be only one of the following:

automaticRestart

boolean

Optional. Specifies whether the instance should be automatically restarted if it is terminated by Compute Engine (not terminated by a user).

Union field _preemptible.

_preemptible can be only one of the following:

preemptible

boolean

Optional. Defines whether the instance is preemptible.

Union field _min_node_cpus.

_min_node_cpus can be only one of the following:

minNodeCpus

integer

Optional. The minimum number of virtual CPUs this instance will consume when running on a sole-tenant node.

Union field _provisioning_model.

_provisioning_model can be only one of the following:

provisioningModel

enum (ProvisioningModel)

Optional. Specifies the provisioning model of the instance.

Union field _instance_termination_action.

_instance_termination_action can be only one of the following:

instanceTerminationAction

enum (InstanceTerminationAction)

Optional. Specifies the termination action for the instance.

Union field _local_ssd_recovery_timeout.

_local_ssd_recovery_timeout can be only one of the following:

localSsdRecoveryTimeout

object (SchedulingDuration)

Optional. Specifies the maximum amount of time a Local Ssd Vm should wait while recovery of the Local Ssd state is attempted. Its value should be in between 0 and 168 hours with hour granularity and the default value being 1 hour.

NodeAffinity

JSON representation
{
  "values": [
    string
  ],

  // Union field _key can be only one of the following:
  "key": string
  // End of list of possible types for union field _key.

  // Union field _operator can be only one of the following:
  "operator": enum (Operator)
  // End of list of possible types for union field _operator.
}
Fields
values[]

string

Optional. Corresponds to the label values of Node resource.

Union field _key.

_key can be only one of the following:

key

string

Optional. Corresponds to the label key of Node resource.

Union field _operator.

_operator can be only one of the following:

operator

enum (Operator)

Optional. Defines the operation of node selection.

SchedulingDuration

JSON representation
{

  // Union field _seconds can be only one of the following:
  "seconds": string
  // End of list of possible types for union field _seconds.

  // Union field _nanos can be only one of the following:
  "nanos": integer
  // End of list of possible types for union field _nanos.
}
Fields

Union field _seconds.

_seconds can be only one of the following:

seconds

string (int64 format)

Optional. Span of time at a resolution of a second.

Union field _nanos.

_nanos can be only one of the following:

nanos

integer

Optional. Span of time that's a fraction of a second at nanosecond resolution.

AcceleratorConfig

JSON representation
{

  // Union field _accelerator_type can be only one of the following:
  "acceleratorType": string
  // End of list of possible types for union field _accelerator_type.

  // Union field _accelerator_count can be only one of the following:
  "acceleratorCount": integer
  // End of list of possible types for union field _accelerator_count.
}
Fields

Union field _accelerator_type.

_accelerator_type can be only one of the following:

acceleratorType

string

Optional. Full or partial URL of the accelerator type resource to attach to this instance.

Union field _accelerator_count.

_accelerator_count can be only one of the following:

acceleratorCount

integer

Optional. The number of the guest accelerator cards exposed to this instance.

LabelsEntry

JSON representation
{
  "key": string,
  "value": string
}
Fields
key

string

value

string

CloudSqlInstanceBackupProperties

JSON representation
{
  "databaseInstalledVersion": string,
  "finalBackup": boolean,
  "sourceInstance": string,
  "instanceCreateTime": string,
  "instanceTier": string,
  "instanceDeleteTime": string
}
Fields
databaseInstalledVersion

string

Output only. The installed database version of the Cloud SQL instance when the backup was taken.

finalBackup

boolean

Output only. Whether the backup is a final backup.

sourceInstance

string

Output only. The source instance of the backup. Format: projects/{project}/instances/{instance}

instanceCreateTime

string (Timestamp format)

Output only. The instance creation timestamp.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

instanceTier

string

Output only. The tier (or machine type) for this instance. Example: db-custom-1-3840

instanceDeleteTime

string (Timestamp format)

Output only. The instance delete timestamp.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

BackupApplianceBackupProperties

JSON representation
{

  // Union field _generation_id can be only one of the following:
  "generationId": integer
  // End of list of possible types for union field _generation_id.

  // Union field _finalize_time can be only one of the following:
  "finalizeTime": string
  // End of list of possible types for union field _finalize_time.

  // Union field _recovery_range_start_time can be only one of the following:
  "recoveryRangeStartTime": string
  // End of list of possible types for union field _recovery_range_start_time.

  // Union field _recovery_range_end_time can be only one of the following:
  "recoveryRangeEndTime": string
  // End of list of possible types for union field _recovery_range_end_time.
}
Fields

Union field _generation_id.

_generation_id can be only one of the following:

generationId

integer

Output only. The numeric generation ID of the backup (monotonically increasing).

Union field _finalize_time.

_finalize_time can be only one of the following:

finalizeTime

string (Timestamp format)

Output only. The time when this backup object was finalized (if none, backup is not finalized).

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

Union field _recovery_range_start_time.

_recovery_range_start_time can be only one of the following:

recoveryRangeStartTime

string (Timestamp format)

Optional. The earliest timestamp of data available in this Backup.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

Union field _recovery_range_end_time.

_recovery_range_end_time can be only one of the following:

recoveryRangeEndTime

string (Timestamp format)

Optional. The latest timestamp of data available in this Backup.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

AlloyDbClusterBackupProperties

JSON representation
{
  "storedBytes": string,
  "chainId": string,
  "databaseVersion": string,

  // Union field _description can be only one of the following:
  "description": string
  // End of list of possible types for union field _description.
}
Fields
storedBytes

string (int64 format)

Output only. Storage usage of this particular backup

chainId

string

Output only. The chain id of this backup. Backups belonging to the same chain are sharing the same chain id. This property is calculated and maintained by BackupDR.

databaseVersion

string

Output only. The PostgreSQL major version of the AlloyDB cluster when the backup was taken.

Union field _description.

_description can be only one of the following:

description

string

An optional text description for the backup.

DiskBackupProperties

JSON representation
{
  "licenses": [
    string
  ],
  "guestOsFeature": [
    {
      object (GuestOsFeature)
    }
  ],
  "replicaZones": [
    string
  ],
  "labels": {
    string: string,
    ...
  },
  "guestFlush": boolean,

  // Union field _description can be only one of the following:
  "description": string
  // End of list of possible types for union field _description.

  // Union field _architecture can be only one of the following:
  "architecture": enum (Architecture)
  // End of list of possible types for union field _architecture.

  // Union field _type can be only one of the following:
  "type": string
  // End of list of possible types for union field _type.

  // Union field _size_gb can be only one of the following:
  "sizeGb": string
  // End of list of possible types for union field _size_gb.

  // Union field _region can be only one of the following:
  "region": string
  // End of list of possible types for union field _region.

  // Union field _zone can be only one of the following:
  "zone": string
  // End of list of possible types for union field _zone.

  // Union field _source_disk can be only one of the following:
  "sourceDisk": string
  // End of list of possible types for union field _source_disk.

  // Union field _access_mode can be only one of the following:
  "accessMode": string
  // End of list of possible types for union field _access_mode.

  // Union field _provisioned_iops can be only one of the following:
  "provisionedIops": string
  // End of list of possible types for union field _provisioned_iops.

  // Union field _provisioned_throughput can be only one of the following:
  "provisionedThroughput": string
  // End of list of possible types for union field _provisioned_throughput.

  // Union field _physical_block_size_bytes can be only one of the following:
  "physicalBlockSizeBytes": string
  // End of list of possible types for union field _physical_block_size_bytes.

  // Union field _enable_confidential_compute can be only one of the following:
  "enableConfidentialCompute": boolean
  // End of list of possible types for union field _enable_confidential_compute.

  // Union field _storage_pool can be only one of the following:
  "storagePool": string
  // End of list of possible types for union field _storage_pool.
}
Fields
licenses[]

string

A list of publicly available licenses that are applicable to this backup. This is applicable if the original image had licenses attached, e.g. Windows image.

guestOsFeature[]

object (GuestOsFeature)

A list of guest OS features that are applicable to this backup.

replicaZones[]

string

The URL of the Zones where the source disk should be replicated.

labels

map (key: string, value: string)

The labels of the source disk.

An object containing a list of "key": value pairs. Example: { "name": "wrench", "mass": "1.3kg", "count": "3" }.

guestFlush

boolean

Optional. Defines if the guest flush is enabled for the source disk. Default value is false.

Union field _description.

_description can be only one of the following:

description

string

A description of the source disk.

Union field _architecture.

_architecture can be only one of the following:

architecture

enum (Architecture)

The architecture of the source disk. Valid values are ARM64 or X86_64.

Union field _type.

_type can be only one of the following:

type

string

The URL of the type of the disk.

Union field _size_gb.

_size_gb can be only one of the following:

sizeGb

string (int64 format)

Size(in GB) of the source disk.

Union field _region.

_region can be only one of the following:

region

string

Region and zone are mutually exclusive fields. The URL of the region of the source disk.

Union field _zone.

_zone can be only one of the following:

zone

string

The URL of the Zone where the source disk.

Union field _source_disk.

_source_disk can be only one of the following:

sourceDisk

string

The source disk used to create this backup.

Union field _access_mode.

_access_mode can be only one of the following:

accessMode

string

The access mode of the source disk.

Union field _provisioned_iops.

_provisioned_iops can be only one of the following:

provisionedIops

string (int64 format)

The number of IOPS provisioned for the source disk.

Union field _provisioned_throughput.

_provisioned_throughput can be only one of the following:

provisionedThroughput

string (int64 format)

The number of throughput provisioned for the source disk.

Union field _physical_block_size_bytes.

_physical_block_size_bytes can be only one of the following:

physicalBlockSizeBytes

string (int64 format)

The physical block size of the source disk.

Union field _enable_confidential_compute.

_enable_confidential_compute can be only one of the following:

enableConfidentialCompute

boolean

Indicates whether the source disk is using confidential compute mode.

Union field _storage_pool.

_storage_pool can be only one of the following:

storagePool

string

The storage pool of the source disk.

LabelsEntry

JSON representation
{
  "key": string,
  "value": string
}
Fields
key

string

value

string

FilestoreInstanceBackupProperties

JSON representation
{
  "sourceInstance": string
}
Fields
sourceInstance

string

Output only. The source instance of the backup.

GCPBackupPlanInfo

JSON representation
{
  "backupPlan": string,
  "backupPlanRuleId": string,
  "backupPlanRevisionName": string,
  "backupPlanRevisionId": string
}
Fields
backupPlan

string

Resource name of backup plan by which workload is protected at the time of the backup. Format: projects/{project}/locations/{location}/backupPlans/{backupPlanId}

backupPlanRuleId

string

The rule id of the backup plan which triggered this backup in case of scheduled backup or used for

backupPlanRevisionName

string

Resource name of the backup plan revision which triggered this backup in case of scheduled backup or used for on demand backup. Format: projects/{project}/locations/{location}/backupPlans/{backupPlanId}/revisions/{revisionId}

backupPlanRevisionId

string

The user friendly id of the backup plan revision which triggered this backup in case of scheduled backup or used for on demand backup.

BackupGcpResource

JSON representation
{
  "gcpResourcename": string,
  "location": string,
  "type": string
}
Fields
gcpResourcename

string

Name of the Google Cloud resource.

location

string

Location of the resource: //"global"/"unspecified".

type

string

Type of the resource. Use the Unified Resource Type, eg. compute.googleapis.com/Instance.

BackupRetentionInheritance

How a backup's enforced retention end time is inherited.

Enums
BACKUP_RETENTION_INHERITANCE_UNSPECIFIED Inheritance behavior not set. This will default to INHERIT_VAULT_RETENTION.
INHERIT_VAULT_RETENTION

The enforced retention end time of a backup will be inherited from the backup vault's backup_minimum_enforced_retention_duration field.

This is the default behavior.

MATCH_BACKUP_EXPIRE_TIME

The enforced retention end time of a backup will always match the expire time of the backup.

If this is set, the backup's enforced retention end time will be set to match the expire time during creation of the backup. When updating, the ERET and expire time must be updated together and have the same value. Invalid update requests will be rejected by the server.

State

Holds the state of the backup resource.

Enums
STATE_UNSPECIFIED State not set.
CREATING The backup is being created.
ACTIVE The backup has been created and is fully usable.
DELETING The backup is being deleted.
ERROR The backup is experiencing an issue and might be unusable.
UPLOADING The backup is being uploaded.

AccessType

The type of configuration.

Enums
ACCESS_TYPE_UNSPECIFIED Default value. This value is unused.
ONE_TO_ONE_NAT ONE_TO_ONE_NAT
DIRECT_IPV6 Direct IPv6 access.

NetworkTier

Network tier property used by addresses, instances and forwarding rules.

Enums
NETWORK_TIER_UNSPECIFIED Default value. This value is unused.
PREMIUM High quality, Google-grade network tier, support for all networking products.
STANDARD Public internet quality, only limited support for other networking products.

StackType

Stack type for this network interface.

Enums
STACK_TYPE_UNSPECIFIED Default should be STACK_TYPE_UNSPECIFIED.
IPV4_ONLY The network interface will be assigned IPv4 address.
IPV4_IPV6 The network interface can have both IPv4 and IPv6 addresses.

Ipv6AccessType

IPv6 access type for this network interface.

Enums
UNSPECIFIED_IPV6_ACCESS_TYPE IPv6 access type not set. Means this network interface hasn't been turned on IPv6 yet.
INTERNAL This network interface can have internal IPv6.
EXTERNAL This network interface can have external IPv6.

NicType

Nic type for this network interface.

Enums
NIC_TYPE_UNSPECIFIED Default should be NIC_TYPE_UNSPECIFIED.
VIRTIO_NET VIRTIO
GVNIC GVNIC

DiskType

List of the Disk Types.

Enums
DISK_TYPE_UNSPECIFIED Default value, which is unused.
SCRATCH A scratch disk type.
PERSISTENT A persistent disk type.

DiskMode

List of the Disk Modes.

Enums
DISK_MODE_UNSPECIFIED Default value, which is unused.
READ_WRITE Attaches this disk in read-write mode. Only one virtual machine at a time can be attached to a disk in read-write mode.
READ_ONLY Attaches this disk in read-only mode. Multiple virtual machines can use a disk in read-only mode at a time.
LOCKED The disk is locked for administrative reasons. Nobody else can use the disk. This mode is used (for example) when taking a snapshot of a disk to prevent mounting the disk while it is being snapshotted.

DiskInterface

List of the Disk Interfaces.

Enums
DISK_INTERFACE_UNSPECIFIED Default value, which is unused.
SCSI SCSI Disk Interface.
NVME NVME Disk Interface.
NVDIMM NVDIMM Disk Interface.
ISCSI ISCSI Disk Interface.

FeatureType

List of the Feature Types.

Enums
FEATURE_TYPE_UNSPECIFIED Default value, which is unused.
VIRTIO_SCSI_MULTIQUEUE VIRTIO_SCSI_MULTIQUEUE feature type.
WINDOWS WINDOWS feature type.
MULTI_IP_SUBNET MULTI_IP_SUBNET feature type.
UEFI_COMPATIBLE UEFI_COMPATIBLE feature type.
SECURE_BOOT SECURE_BOOT feature type.
GVNIC GVNIC feature type.
SEV_CAPABLE SEV_CAPABLE feature type.
BARE_METAL_LINUX_COMPATIBLE BARE_METAL_LINUX_COMPATIBLE feature type.
SUSPEND_RESUME_COMPATIBLE SUSPEND_RESUME_COMPATIBLE feature type.
SEV_LIVE_MIGRATABLE SEV_LIVE_MIGRATABLE feature type.
SEV_SNP_CAPABLE SEV_SNP_CAPABLE feature type.
TDX_CAPABLE TDX_CAPABLE feature type.
IDPF IDPF feature type.
SEV_LIVE_MIGRATABLE_V2 SEV_LIVE_MIGRATABLE_V2 feature type.

DiskSavedState

List of the states of the Disk.

Enums
DISK_SAVED_STATE_UNSPECIFIED Default Disk state has not been preserved.
PRESERVED Disk state has been preserved.

OnHostMaintenance

Defines the maintenance behavior for this instance=

Enums
ON_HOST_MAINTENANCE_UNSPECIFIED Default value. This value is unused.
TERMINATE Tells Compute Engine to terminate and (optionally) restart the instance away from the maintenance activity.
MIGRATE Default, Allows Compute Engine to automatically migrate instances out of the way of maintenance events.

Operator

Defines the type of node selections.

Enums
OPERATOR_UNSPECIFIED Default value. This value is unused.
IN Requires Compute Engine to seek for matched nodes.
NOT_IN Requires Compute Engine to avoid certain nodes.

ProvisioningModel

Defines the provisioning model for an instance.

Enums
PROVISIONING_MODEL_UNSPECIFIED Default value. This value is not used.
STANDARD Standard provisioning with user controlled runtime, no discounts.
SPOT Heavily discounted, no guaranteed runtime.

InstanceTerminationAction

Defines the supported termination actions for an instance.

Enums
INSTANCE_TERMINATION_ACTION_UNSPECIFIED Default value. This value is unused.
DELETE Delete the VM.
STOP Stop the VM without storing in-memory content. default action.

KeyRevocationActionType

Specifies whether the virtual machine instance will be shut down on key revocation. It is currently used in instance, instance properties and GMI protos

Enums
KEY_REVOCATION_ACTION_TYPE_UNSPECIFIED Default value. This value is unused.
NONE Indicates user chose no operation.
STOP Indicates user chose to opt for VM shutdown on key revocation.

Architecture

Architecture of the source disk.

Enums
ARCHITECTURE_UNSPECIFIED Default value. This value is unused.
X86_64 Disks with architecture X86_64
ARM64 Disks with architecture ARM64

BackupType

Type of the backup, scheduled or ondemand.

Enums
BACKUP_TYPE_UNSPECIFIED Backup type is unspecified.
SCHEDULED Scheduled backup.
ON_DEMAND On demand backup.
ON_DEMAND_OPERATIONAL Operational backup.

Tool Annotations

Destructive Hint: ❌ | Idempotent Hint: ✅ | Read Only Hint: ✅ | Open World Hint: ❌